// Name: Signature stamp
// Submenu: 
// Author:MadJik (Jean-Claude JAY)
// Title: Signature stamp
// Version: 1.5
// Desc: Add your signature quickly to your art
// Keywords: text|signature|stamp|watermark
// URL: http://forums.getpaint.net/index.php?showtopic=112441
#region UICode
CheckboxControl Amount1 = false; // [0,1] Personal signature
TextboxControl Amount2 = "your text here"; // [0,255] {!Amount1} Signature text
IntSliderControl Amount3 = 10; // [5,100] Size (10=100% for image)
FontFamily Amount4 = new FontFamily("Arial"); // Font
ListBoxControl Amount5 = 0; // Font style|0=Normal|1=Italic|2=Bold|3=Bold Italic  
IntSliderControl Amount6 = 4; // [-10,400] Margin
ListBoxControl Amount7 = 4; // Position|0=Top-Left|1=Top|2=Top-Right|3=Right|4=Bottom-Right|5=Bottom|6=Bottom-Left|7=Left|8=Center
CheckboxControl Amount8 = true; // [0,1] AntiAlias
ListBoxControl Amount9 = 1; // Draw with secondary color|0=Nothing|1=Outline|2=Trail|3=Empty Rectangle|4=Filled Rectangle
ColorWheelControl Amount10 = ColorBgra.FromBgr(0,0,0); // [PrimaryColor] Fore color
IntSliderControl Amount11 = 255; // [0,255] Fore color transparency
ColorWheelControl Amount12 = ColorBgra.FromBgr(255,255,255); // [SecondaryColor] Back color
IntSliderControl Amount13 = 120; // [0,255] Back color transparency
CheckboxControl Amount14 = false; // [0,1] Swap Colors
CheckboxControl Amount15 = false; // [0,1] Text is a valid path to an image.png
#endregion

void Render(Surface dst, Surface src, Rectangle rect)
{
  Rectangle selection = EnvironmentParameters.GetSelection(src.Bounds).GetBoundsInt();
  dst.CopySurface(src, rect.Location, rect);
  if (IsCancelRequested) return;
  int w = selection.Width;
  //Here you define your "personal signature" 
  //Values added here will override settings from the UI (add {!Amount1} on lines 11 to 24 if you want to disable on the UI)
  //Only add values you don't need to change for your signature. Uncomment (remove //) to activate a line.
  if (Amount1)
  {
    //string UserName = System.Security.Principal.WindowsIdentity.GetCurrent().Name; 
    string UserName = "MadJik"; // © MadJik 2018

    Amount2 = UserName + "  " + DateTime.Now.ToString("yyyy-MM");                                            // Signature text           //give: MadJik year-month
    Amount3 = 8 + ((w < 1000) ? 0 : 2) + ((w < 1500) ? 0 : 3) + ((w < 2000) ? 0 : 4) + ((w < 2500) ? 0 : 5); // Size (10=100% for image) //size change with width
    Amount4 = new FontFamily("Century Gothic");                                                              // Font
    //Amount5 = 2;                                                                                           // Font style|0=Normal|1=Italic|2=Bold|3=Bold Italic  
    //Amount6 = 1;                                                                                           // Margin 
    //Amount7 = 4;                                                                                           // Position|0=Top-Left|1=Top|2=Top-Right|3=Right|4=Bottom-Right|5=Bottom|6=Bottom-Left|7=Left|8=Center
    //Amount8 = true;                                                                                        // AntiAlias
    //Amount9 = 1;                                                                                           // Draw with secondary color|0=Nothing|1=Outline|2=Trail|3=Empty Rectangle|4=Filled Rectangle
    //Amount10 = ColorBgra.FromBgr(0, 0, 0);                                                                 // Fore color
    //Amount11 = 255;                                                                                        // Fore color transparency
    //Amount12 = ColorBgra.FromBgr(180, 180, 180);                                                           // Back color
    //Amount13 = 160;                                                                                        // Back color transparency
    //Amount14 = false;                                                                                      // Swap Colors
    // for an image type the valid path in Amount2 line 41 like: Amount2 = @"h:\pdn\sig2018.png";
  }

  if (Amount15 && !File.Exists(Amount2))
  {
      Amount15 = false;
      Amount2 = Amount2 + ":Error!";
  }

  Amount10.A = (byte)Amount11;
  Amount12.A = (byte)Amount13;
  Pen Pen1 = new Pen(Amount12);
  SolidBrush Brush1 = new SolidBrush(Amount12);
  SolidBrush Brush2 = new SolidBrush(Amount10);
  if (Amount14)
  {
    Brush1 = new SolidBrush(Amount10);
    Brush2 = new SolidBrush(Amount12);
    Pen1 = new Pen(Amount10);
  }

  Graphics g = new RenderArgs(dst).Graphics;
  g.Clip = new Region(rect);
  if (Amount8)
  {
    g.SmoothingMode = SmoothingMode.AntiAlias;
    g.InterpolationMode = InterpolationMode.HighQualityBicubic;
    g.PixelOffsetMode = PixelOffsetMode.HighQuality;
  }
  else
  {
    g.SmoothingMode = SmoothingMode.Default;
    g.TextRenderingHint = TextRenderingHint.SingleBitPerPixelGridFit; //add this line to make text good looking
  }

  // case 0: //Normal
  FontStyle sf = System.Drawing.FontStyle.Regular;

  switch (Amount5)
  {
    case 1: //Italic
      sf = System.Drawing.FontStyle.Italic;
      break;
    case 2: //Bold
      sf = System.Drawing.FontStyle.Bold;
      break;
    case 3: //Bold Italic
      sf = System.Drawing.FontStyle.Italic | System.Drawing.FontStyle.Bold;
      break;
  }
  Font SelectedFont = new Font(Amount4, Amount3, sf);

  string SigText = Amount2;
  Size stringSize = g.MeasureString(SigText, SelectedFont).ToSize();

  int TextW = stringSize.Width;
  int TextH = stringSize.Height;

  Bitmap tmpb = null;
  Bitmap b = null;

  if (Amount15)
  {
    // read an image
    try
    {
      tmpb = (Bitmap)Bitmap.FromFile(Amount2);
      if (Amount3 != 10)
      {
        int newwidth = (int)(tmpb.Width * (float)(Amount3 / 10f));
        int newheight = (int)(tmpb.Height * (float)(Amount3 / 10f));
        b = ResizeImage(tmpb, newwidth, newheight);
      }
      else
      {
        b= tmpb;
      }
      TextW = b.Width;
      TextH = b.Height;
    }
    catch
    {
      Amount15 = false;
      SigText = Amount2 + ":Error!";
      stringSize = g.MeasureString(SigText, SelectedFont).ToSize();
      TextW = stringSize.Width;
      TextH = stringSize.Height;
    }
  }

  // case 0: //Top-Left
  int TopX = selection.Left + Amount6;
  int TopY = selection.Top + Amount6;

  switch (Amount7)
  {
    case 1: //Top
      TopX = (selection.Width - TextW) / 2 + selection.Left;
      break;
    case 2: //Top-Right
      TopX = selection.Width - TextW + selection.Left - Amount6;
      break;
    case 3: //Right
      TopX = selection.Width - TextW + selection.Left - Amount6;
      TopY = (selection.Height - TextH) / 2 + selection.Top;
      break;
    case 4: //Bottom-Right
      TopX = selection.Width - TextW + selection.Left - Amount6;
      TopY = selection.Height - TextH + selection.Top - Amount6;
      break;
    case 5: //Bottom
      TopX = (selection.Width - TextW) / 2 + selection.Left;
      TopY = selection.Height - TextH + selection.Top - Amount6;
      break;
    case 6: //Bottom-Left
      TopY = selection.Height - TextH + selection.Top - Amount6;
      break;
    case 7: //Left
      TopY = (selection.Height - TextH) / 2 + selection.Top;
      break;
    case 8: //Center
      TopX = (selection.Width - TextW) / 2 + selection.Left;
      TopY = (selection.Height - TextH) / 2 + selection.Top;
      break;
  }
  if (Amount15)
  {
    // insert an image
    g.DrawImage(b, TopX, TopY);
  }
  else
  {
    switch (Amount9)
    {
      case 1: // draw 4x string with +/- decal for the background
        g.DrawString(SigText, SelectedFont, Brush1, TopX - 1, TopY - 1);
        g.DrawString(SigText, SelectedFont, Brush1, TopX - 1, TopY + 1);
        g.DrawString(SigText, SelectedFont, Brush1, TopX + 1, TopY - 1);
        g.DrawString(SigText, SelectedFont, Brush1, TopX + 1, TopY + 1);
        break;
      case 2: // draw 4x string with ++++ decal for the trail
        g.DrawString(SigText, SelectedFont, Brush1, TopX + 1, TopY + 1);
        g.DrawString(SigText, SelectedFont, Brush1, TopX + 2, TopY + 2);
        g.DrawString(SigText, SelectedFont, Brush1, TopX + 3, TopY + 3);
        g.DrawString(SigText, SelectedFont, Brush1, TopX + 4, TopY + 4);
        break;
      case 3: // draw rectangle 
        g.DrawRectangle(Pen1, TopX - 4, TopY - 2, TextW + 2, TextH + 4);
        break;
      case 4: // fill rectangle 
        g.FillRectangle(Brush1, TopX - 4, TopY - 2, TextW + 2, TextH + 4);
        break;
    }

    // foreground draw
    g.DrawString(SigText, SelectedFont, Brush2, TopX, TopY);
  }
    
  // Dispose objects
  Brush1.Dispose();
  Brush2.Dispose();
  g.Dispose();
  SelectedFont.Dispose();
  if (b != null) b.Dispose();
  if (tmpb != null) tmpb.Dispose();
}

public static Bitmap ResizeImage(Bitmap image, int width, int height)
{
// function provided by BoltBait
  var destRect = new Rectangle(0, 0, width, height);
  var destImage = new Bitmap(width, height);

  destImage.SetResolution(image.HorizontalResolution, image.VerticalResolution);

  using (var graphics = Graphics.FromImage(destImage))
  {
    graphics.CompositingMode = CompositingMode.SourceCopy;
    graphics.CompositingQuality = CompositingQuality.HighQuality;
    graphics.InterpolationMode = InterpolationMode.HighQualityBicubic;
    graphics.SmoothingMode = SmoothingMode.HighQuality;
    graphics.PixelOffsetMode = PixelOffsetMode.HighQuality;

    using (var wrapMode = new System.Drawing.Imaging.ImageAttributes())
    {
      wrapMode.SetWrapMode(WrapMode.Clamp);
      graphics.DrawImage(image, destRect, 0, 0, image.Width, image.Height, GraphicsUnit.Pixel, wrapMode);
    }
  }
  return destImage;
}